#include "StdAfx.h"
#include "ClassExample.h"
#include "ClassExampleDlg.h"
#include "Td3dDrawable.h"


void
CClassExampleDlg::LinkDrawableToD3d(UINT	idcPlaceHolderName, Td3dDrawable *drawable)
{
		// a. use the idcPlaceHolder to figure out how large
	//    is the initial on-screen area for the D3D window
	//
	CWnd* pStatic = this->GetDlgItem(idcPlaceHolderName);
	CRect staticRect;
	pStatic->GetWindowRect(&staticRect);

	//
	// b. destroy the place holder, 
	//
	pStatic->DestroyWindow();	// Since the static was just a place holder, destroy it
								// convert the static's screen rectangle to the dialog's 
								// client coordinates
	//
	// c. use the on-screen area information to create a D3D device
	//
	ScreenToClient(&staticRect);
	if (!drawable->Create(NULL,	//CWnd default
					NULL,			//has no name
					WS_CHILD|WS_CLIPSIBLINGS|WS_CLIPCHILDREN|WS_VISIBLE|WS_BORDER,
					staticRect,		// Dimension and location of the place-holder
					this,			//this is the parent
					idcPlaceHolderName) ) { //Use the ID of the just destroyed static
		MessageBox("D3DX Device Creation Failed!!");
	}

	// d. Initialize the Direct3D Device
	//
	if (!drawable->InitD3D(fD3D)) {
		MessageBox("D3D device initialization failed!");
	}

  	drawable->BringWindowToTop();
}

void
CClassExampleDlg::LinkControlToPlaceHolder(UINT idcPlaceHolderName, UINT controlTag, CDialog *control)
{
	// a. use the idcPlaceHolder to figure out how large
	//    is the initial on-screen area for the D3D window
	//
	CWnd* pStatic = this->GetDlgItem(idcPlaceHolderName);
	CRect staticRect;
	pStatic->GetWindowRect(&staticRect);
	ScreenToClient(&staticRect);

	//
	// b. destroy the place holder, 
	//
	pStatic->DestroyWindow();	// Since the static was just a place holder, destroy it
								// convert the static's screen rectangle to the dialog's 
								// client coordinates
	const CPoint &topLeft = staticRect.TopLeft();
	if ( !control->Create(controlTag, this) ) {
		MessageBox("Creation of control Dialog Failed!!");
	}
	control->SetWindowPos(NULL, topLeft.x, topLeft.y, staticRect.Width(), staticRect.Height(), 0);
	control->BringWindowToTop();
		//
	control->ShowWindow(SW_SHOWDEFAULT);
	control->UpdateWindow();
}