#include "StdAfx.h"
#include "ClassExample.h"
#include "ClassExampleDlg.h"



BOOL
CClassExampleDlg::PreTranslateMessage(MSG* pMsg) 
{
	switch (pMsg->message) {
		case WM_KEYDOWN:
			MyServiceOnKeyDown(pMsg->wParam);
			return TRUE;	// we will _CONSUME_ this character and not let any other Dialog sees this
			break;

		case WM_KEYUP:
			MyServiceOnKeyUp(pMsg->wParam);
			return TRUE;	// we will _CONSUME_ this character and not let any other Dialog sees this
							// if we do not return TRUE here and instead calls the CDialog::PreTranslateMessage
							// then this character will propergate around, then you may ended up
							// with typing one character and two things happens in your system
				//
				// case in point: left/right arrow will move the slider bar in the control panel
				//
			break;
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CClassExampleDlg::MyServiceOnKeyDown(UINT nChar) 
{
	//
	// the nChar passed in a "virtual-key codes"
	// look under MSDN for more detials, here
	// I am just going to decode a few that is important
	// to my driving game :-)
	//
	//
	CString msg;
	static int count = 0;
	count++;

	switch (nChar) {
		case VK_UP:	// upward arrow
			msg.Format("Up Arrow down code=(%d) Count(%d)", nChar, count);
			break;

		case VK_DOWN:	// down-ward arrow
			msg.Format("Down Arrow down code=(%d) Count(%d)", nChar, count);
			break;

		case VK_RIGHT:	// right  arrow
			msg.Format("Right Arrow down code=(%d) Count(%d)", nChar, count);
			break;

		case VK_LEFT:	// left arrow
			msg.Format("Left Arrow down code=(%d) Count(%d)", nChar, count);
			break;
	}

	EchoToStatusArea(msg);
}

void CClassExampleDlg::MyServiceOnKeyUp(UINT nChar) 
{
	// if you need to know when the keyboard key goes up
	static int count = 0;
	count++;
	CString msg;
	msg.Format("Keyboard key just came up UpCount(%d)", count);
	EchoToStatusArea(msg);
}
