#include "TnormRectangle.h"
#include "Tcircle.h"

	TmyVertex TnormRectangle::sfRectangleVertices[4];

void TnormRectangle::sInitializeNormRectangle(Td3dDrawable*)
{
	for (int i=0; i<4; i++) {
		sfRectangleVertices[i].fU = sfRectangleVertices[i].fV = 
		sfRectangleVertices[i].fU1 = sfRectangleVertices[i].fV1 = 0.0f;
	}
	sfRectangleVertices[3].fColor = D3DCOLOR_COLORVALUE(0.9f, 0.9f, 0.9f, 0.0);

	sfRectangleVertices[0].fPoint.x =  0.0f; 
	sfRectangleVertices[0].fPoint.y =  0.0f; 
	sfRectangleVertices[0].fPoint.z =  0.0f;
	sfRectangleVertices[0].fU = sfRectangleVertices[0].fU1 = 0.0f;
	sfRectangleVertices[0].fV = sfRectangleVertices[0].fV1 = 1.0f;

	sfRectangleVertices[1].fPoint.x =  1.0f;
	sfRectangleVertices[1].fPoint.y =  0.0f;
	sfRectangleVertices[1].fPoint.z =  0.0f;
	sfRectangleVertices[1].fU = sfRectangleVertices[1].fU1 = 1.0f;
	sfRectangleVertices[1].fV = sfRectangleVertices[1].fV1 = 1.0f;

	sfRectangleVertices[2].fPoint.x =  0.0f;
	sfRectangleVertices[2].fPoint.y =  1.0f;
	sfRectangleVertices[2].fPoint.z =  0.0f;
	sfRectangleVertices[2].fU = sfRectangleVertices[2].fU1 = 0.0f;
	sfRectangleVertices[2].fV = sfRectangleVertices[2].fV1 = 0.0f;

	sfRectangleVertices[3].fPoint.x =  1.0f;
	sfRectangleVertices[3].fPoint.y =  1.0f;
	sfRectangleVertices[3].fPoint.z =  0.0f;
	sfRectangleVertices[3].fU = sfRectangleVertices[3].fU1 = 1.0f;
	sfRectangleVertices[3].fV = sfRectangleVertices[3].fV1 = 0.0f;
}

TnormRectangle::TnormRectangle() 
{
	CreateCollisionCircles(1);
	fCollisionCirclesInOC[0].SetFirstPosition(D3DXVECTOR3(0.5f, 0.5f, 0.0));
	fCollisionCirclesInOC[0].SetRadius(0.5f);
}

TnormRectangle::~TnormRectangle() 
{
	// collision circle deletion is handled by the TgraphicsObject destructor
}


bool TnormRectangle::IntersectsBound(
	const T2dBound &b
)
{
	const D3DXVECTOR3 &c = GetXformInfo().Movement();
	float w = GetXformInfo().ScaleX();
	float h = GetXformInfo().ScaleY();
	T2dBound myB(c.x, c.x+w, c.y, c.y+w);
	return b.BoundIntersect(myB);
}

void TnormRectangle::DrawObjectGeom(
	Td3dDrawable&,
	LPDIRECT3DDEVICE9 d3dDevice
)
{
	for (int i=0; i<2; i++) {
		sfRectangleVertices[i].fColor = D3DCOLOR_COLORVALUE(fDrawColor.r, fDrawColor.g, fDrawColor.b, 0.0f);
	}
	d3dDevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, (CONST void *)sfRectangleVertices, sizeof(TmyVertex));
}
