#ifndef _TVALUATOR_H
#define _TVALUATOR_H

	//
	// Measures one dimension movement and translates
	// into a scale. Linearly mapping:
	//		
	//		min<-->max
	//
	//		=> this is the device range (e.g. in pixel)
	//
	// to 
	//
	// 		maxValue <-> minValue
	//
	//		=> this is the value meaningful to the user (e.g. magnifying scale)
	//
class Tvaluator {

	private:
		float	fMin, fMax;
		float	fMinValue, fScale;
	
	public:
		void InitializeValuator(float min, float max, float minValue, float maxValue);
		float GetValue(float v) const;
};

#endif
