#include "Tworld.h"

#include "../GraphicsAPI/TfileTexture.h"

Tworld::Tworld(Td3dDrawable &d1, Td3dDrawable &d2) :
	fDrawTexture1(d1.D3DDevice()),
	fDrawTexture2(d2.D3DDevice()),

	fFire1(d1.D3DDevice()),
	fFire2(d2.D3DDevice()),

	fSmoke1(d1.D3DDevice()),
	fSmoke2(d2.D3DDevice())

{
	SetToDrawCircle();
	fTextureEnabled = false;
	fTransparencyEnabled = false;
	fTextureIndex = -1;

	InitObject(0, 0);
	CompleteObjectAt(2, 2);

	//
	// Do Draw Texture initialization ...
	fDrawTexture1.CreateD3DTexture(kDrawTextureSize);
	fDrawTexture2.CreateD3DTexture(kDrawTextureSize);
		// now set the texture into Td3dDrawable::fTextureLibrary ...
	d1.ReplaceTextureAt(7, &fDrawTexture1);
	d2.ReplaceTextureAt(7, &fDrawTexture2);

	// Fire ...
	fFire1.CreateD3DTexture(kFireTextureSize);
	fFire2.CreateD3DTexture(kFireTextureSize);
	d1.ReplaceTextureAt(8, &fFire1);
	d2.ReplaceTextureAt(8, &fFire2);
	

	// Smoke ...
	fSmoke1.CreateD3DTexture(kSmokeTextureSize);
	fSmoke2.CreateD3DTexture(kSmokeTextureSize);
	d1.ReplaceTextureAt(9, &fSmoke1);
	d2.ReplaceTextureAt(9, &fSmoke2);

}

void 
Tworld::DrawWorld(Td3dDrawable &d, LPDIRECT3DDEVICE9 d3dDevice) 
{
	fAllObject.DrawObject(d);
}

