#pragma once
// Td3dZoomDrawable

#include "Td3dDrawable.h"

#include "GraphicsAPI/GraphicsAPI.h"
		// D3D specific incldues are in GraphicsAPI
#include "GraphicsAPI/Trectangle.h"
#include "GraphicsAPI/Tvaluator.h"


class Td3dZoomDrawable : public Td3dDrawable
{
	DECLARE_DYNAMIC(Td3dZoomDrawable)

public:
	Td3dZoomDrawable();
	virtual ~Td3dZoomDrawable();
	
	// Event Service Routines
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	
	void SetMainDrawable(Td3dDrawable *d) { 
				fMainDrawable = d; 
				ComputeMainArea();
	}

protected:
	DECLARE_MESSAGE_MAP()
	virtual void DrawableSpecificDraws();
	
	void ComputeMainArea();
	void MoveMainAreaTo(const D3DXVECTOR3 &wcPt);
	void ScaleMainDrawableWC(float xMove);

	Td3dDrawable *fMainDrawable;
	Trectangle fMainArea;

	T2dBound fTmpBound;
	Tvaluator fValuator;
private:
};
