#pragma once

// TsliderCtrlWithEcho
// 		1. Support echoing of slider value to the a static text
// 		2. Support floating point slider range (with resolution of 100K)

class TsliderCtrlWithEcho : public CSliderCtrl
{
	DECLARE_DYNAMIC(TsliderCtrlWithEcho)

public:
	TsliderCtrlWithEcho();
	virtual ~TsliderCtrlWithEcho();

	void	InitializeSliderWithEcho(CString *echo, float min, float max, float init, int maxRange = kMaxSliderRange);
	void	SetSliderValue(float userValue) { SetPos(userToMFCPos(userValue) ); UpdateData(true); }
	float	GetSliderValue() { return mfcToUserPos(GetPos()); }
	void  	UpdateSliderEcho() { fSliderEcho->Format("%.2f", mfcToUserPos(GetPos())); }

protected:
	DECLARE_MESSAGE_MAP()
	
	int		userToMFCPos(float userValue) { 
					return int(((userValue - fMinRange) * fMaxSliderRange / fTotalRange)+0.5f); 
			}
	float	mfcToUserPos(int mfcValue) { return (fMinRange + ( (float(mfcValue) / float(fMaxSliderRange)) * fTotalRange)); }
	void  	UpdateSliderEcho(float userValue) { fSliderEcho->Format("%.2f", userValue); }
	

private:
	static const int kMaxSliderRange = 100000;
	int			fMaxSliderRange;

	CString		*fSliderEcho;	// This is where the slider's echo will show up

	float		fMinRange;		// Min Range number
	float		fTotalRange;	// Total range covered from min to max
};


